#!/etc/opt/openit/perl -w

use strict;

my $directive = $ARGV[ 0 ];
my $new_directive = join " ", @ARGV[ 1 .. $#ARGV ];
$new_directive .= "\n";

my $cfg = "/etc/opt/openit/openit.cfg";
my $old = "$cfg.old";
my $new = "$cfg.new";

# Only root can patch
if ( $< ne 0 ) {
    die "Error: Patching must be done as 'root'!\n";
}

open(OUT, ">$new") || die "Error: Can't write new cfg '$new'!\n";
open(IN, "<$cfg") || die "Error: Unable to read old cfg '$cfg'!\n";

# Copy top definitions from old config
my $replaced = 0;
while(my $line = <IN>) {
    if($line =~ /^$directive\s/) {       # Replace existing
	print OUT $new_directive;
	$replaced = 1;
    } else {
	print OUT $line;
    }
}
close(IN);

if( ! $replaced ) {                      # Add if not seen before
    print OUT "$new_directive";
}

close(OUT);

if( ! rename($cfg, $old)) {
    die "Error: Unable to rename previous config to '$old'!\n";
}

if( ! rename($new, $cfg)) {
    die "Error: Unable to rename new config to '$cfg'!\n";
}

exit 0;
