#!/etc/opt/openit/perl -w

use strict;

my $directive = $ARGV[ 0 ];
my $new_directive = join " ", @ARGV[ 1 .. $#ARGV ];
$new_directive .= "\n";

my $cfg = "/var/opt/openit/etc/dist_replace";
my $old = "$cfg.old";
my $new = "$cfg.new";

# Only root can patch
if ( $< ne 0 ) {
    die "Error: Patching must be done as 'root'!\n";
}

open(IN, "<$cfg") || die "Error: Unable to read old cfg '$cfg'!\n";

# Read in existing file
my @lines = <IN>;
close(IN);

# Check if acc_types already exists
if ( grep( /acc_types/, @lines ) ) {
   exit 0;
}

# Else insert
splice @lines, 1, 0, " (\$CONFIG_DIR/acc_types,                acc_types),\n";

# Print updated config
open(OUT, ">$new") || die "Error: Can't write new cfg '$new'!\n";
foreach (@lines) {
    print OUT;
}
close(OUT);

if( ! rename($cfg, $old)) {
    die "Error: Unable to rename previous config to '$old'!\n";
}

if( ! rename($new, $cfg)) {
    die "Error: Unable to rename new config to '$cfg'!\n";
}

exit 0;
